--[[ Inspect
     Get more information about the inspected unit
  ]]

if not FixR then return end

local DefaultO = {}
local misc = {
  ["desc"] = "Get more information about the inspected unit";
  ["alpha"] = true;
  ["GUI"] = {
    [1] = {
      ["type"] = "Button";
      ["opt"] = "raid history";
      ["func"] = function(self) self:SetOption("inspect"); end;
    };
    [2] = {
      ["type"] = "Button";
      ["opt"] = "talent spec";
      ["func"] = function(self) self:SetOption("talents"); end;
    };
  };
}

local M = FixR:NewModule("Inspect", DefaultO, misc)
--FixRInspect_DumpCategoryId("bla")
--FixRInspect_DumpStatisticIds_ByCategoryId(123)
local InspectFrame = nil
local InspectFrameEvents = {};
local statIds = {
  [1] = {
    ["short"] = "CLASSIC";
    ["instances"] = {
    };
  };
  [2] = {
    ["short"] = "BC";
    ["instances"] = {
    };
  };
  [3] = {
    ["short"] = "WOTLK";
    ["instances"] = {
    };
  };
  [4] = {
    ["short"] = "CAT";
    ["instances"] = {
      [1] = {
        ["instanceName"] = "Firelands";
        ["short"] = "FL";
        ["d"] = {
          [1] = {
            ["type"] = "N";
            ["ids"] = {5964, 5966, 5968, 5970, 5972, 5974, 5976}; --Beth,Ryho,Shan,Alys,Bale,Majo,Ragn
          };
          [2] = {
            ["type"] = "H";
            ["ids"] = {5965, 5967, 5969, 5971, 5973, 5975, 5977}; --Beth,Ryho,Shan,Alys,Bale,Majo,Ragn
          };
        };
      };
      [2] = {
        ["instanceName"] = "Dragon Soul";
        ["short"] = "DS";
        ["d"] = {
          [1] = {
            ["type"] = "N";
            ["ids"] = {6153, 6155, 6157, 6159, 6161, 6163, 6165, 6167}; --Morc,Zono,Yors,Haga,Ultr,Blac,Spin,Deat
          };
          [2] = {
            ["type"] = "H";
            ["ids"] = {6154, 6156, 6158, 6160, 6162, 6164, 6166, 6168}; --Morc,Zono,Yors,Haga,Ultr,Blac,Spin,Deat
          };
        };
      };
    };
  };
  [5] = {
    ["short"] = "MOP";
    ["instances"] = {
      [1] = {
        ["instanceName"] = "Mogu'shan Vaults";
        ["short"] = "MV";
        ["d"] = {
          [1] = {
            ["p"] = 25;
            ["type"] = "L";
            ["ids"] = {6983, 6984, 6985, 6986, 6987, 6988}; --Ston,Feng,Gara,Spir,Eleg,WotE
          };
          [2] = {
            ["p"] = 10;
            ["type"] = "N";
            ["ids"] = {6789, 6791, 6793, 6795, 6797, 6799}; --Ston,Feng,Gara,Spir,Eleg,WotE
          };
          [3] = {
            ["p"] = 10;
            ["type"] = "H";
            ["ids"] = {6790, 6792, 6794, 6796, 6798, 6800}; --Ston,Feng,Gara,Spir,Eleg,WotE
          };
          [4] = {
            ["p"] = 25;
            ["type"] = "N";
            ["ids"] = {7914, 7917, 7919, 7921, 7923, 7926}; --Ston,Feng,Gara,Spir,Eleg,WotE
          };
          [5] = {
            ["p"] = 25;
            ["type"] = "H";
            ["ids"] = {7915, 7918, 7920, 7922, 7924, 7927}; --Ston,Feng,Gara,Spir,Eleg,WotE
          };
        };
      };
      [2] = {
        ["instanceName"] = "Heart of Fear";
        ["short"] = "HOF";
        ["d"] = {
          [1] = {
            ["p"] = 25;
            ["type"] = "L";
            ["ids"] = {6991, 6992, 6993, 6994, 6995, 6996}; --Zorl,Taya,Gara,Melj,Unso,Shek
          };
          [2] = {
            ["p"] = 10;
            ["type"] = "N";
            ["ids"] = {6801, 6803, 6805, 6807, 6809, 6811}; --Zorl,Taya,Gara,Melj,Unso,Shek
          };
          [3] = {
            ["p"] = 10;
            ["type"] = "H";
            ["ids"] = {6802, 6804, 6806, 6808, 6810, 6812}; --Zorl,Taya,Gara,Melj,Unso,Shek
          };
          [4] = {
            ["p"] = 25;
            ["type"] = "N";
            ["ids"] = {7951, 7954, 7956, 7958, 7961, 7963}; --Zorl,Taya,Gara,Melj,Unso,Shek
          };
          [5] = {
            ["p"] = 25;
            ["type"] = "H";
            ["ids"] = {7953, 7955, 7957, 7960, 7962, 7964}; --Zorl,Taya,Gara,Melj,Unso,Shek
          };
        };
      };
      [3] = {
        ["instanceName"] = "Terrace of Endless Spring";
        ["short"] = "TOES";
        ["d"] = {
          [1] = {
            ["p"] = 25;
            ["type"] = "L";
            ["ids"] = {6997, 6998, 6999, 7000}; --Prot,Tsul,LeiS,ShaF
          };
          [2] = {
            ["p"] = 10;
            ["type"] = "N";
            ["ids"] = {6813, 6815, 6817, 6819}; --Prot,Tsul,LeiS,ShaF
          };
          [3] = {
            ["p"] = 10;
            ["type"] = "H";
            ["ids"] = {6814, 6816, 6818, 6820}; --Prot,Tsul,LeiS,ShaF
          };
          [4] = {
            ["p"] = 25;
            ["type"] = "N";
            ["ids"] = {7965, 7967, 7969, 7971}; --Prot,Tsul,LeiS,ShaF
          };
          [5] = {
            ["p"] = 25;
            ["type"] = "H";
            ["ids"] = {7966, 7968, 7970, 7972}; --Prot,Tsul,LeiS,ShaF
          };
        };
      };
      [4] = {
        ["instanceName"] = "Throne of Thunder";
        ["short"] = "TOT";
        ["d"] = {
          [1] = {
            ["p"] = 25;
            ["type"] = "L";
            ["ids"] = {8141, 8148, 8153, 8158, 8163, 8168, 8173, 8178, 8183, 8188, 8193, 8198};
          };
          [2] = {
            ["p"] = 10;
            ["type"] = "N";
            ["ids"] = {8142, 8149, 8154, 8159, 8164, 8169, 8174, 8179, 8184, 8189, 8194, 8199};
          };
          [3] = {
            ["p"] = 10;
            ["type"] = "H";
            ["ids"] = {8144, 8151, 8156, 8162, 8166, 8171, 8176, 8181, 8186, 8191, 8196, 8202, 8203};
          };
          [4] = {
            ["p"] = 25;
            ["type"] = "N";
            ["ids"] = {8143, 8150, 8155, 8160, 8165, 8170, 8175, 8182, 8185, 8190, 8195, 8200};
          };
          [5] = {
            ["p"] = 25;
            ["type"] = "H";
            ["ids"] = {8145, 8152, 8157, 8161, 8167, 8172, 8177, 8180, 8187, 8192, 8197, 8201, 8256};
          };
        };
      };
    };
  };
};
local inspectResultsFrame = nil
local waitingForInspect = false
local waitingForStatistics = false
--local fixRInspect_waitingFlags = 0x0 --0b0001: equipped items, 0b0010: statistics
local function IsKill(str)
  return (str ~= "--")
end
local function IncreaseIfKill(val, str)
  if str == "--" then
    return (val)
  end
  return (val+1)
end
local function getAvgItemlevelOfUnit(unit)
  local slotid, itemid, levelaccum, itemcount, levelavg = 0, 0, 0, 0, 0
  local missedSlots = 0
  --HeadSlot: 1, NeckSlot: 2, ShoulderSlot: 3
  --ChestSlot: 5, WaistSlot: 6, LegsSlot: 7, FeetSlot: 8, WristSlot: 9, HandsSlot: 10, Finger0Slot: 11, Finger1Slot: 12, Trinket0Slot: 13, Trinket1Slot: 14, BackSlot: 15, MainHandSlot: 16, SecondaryHandSlot: 17, RangedSlot: 18
  for slotid = 1, 3, 1 do
    --itemid = GetInventoryItemID(unit, slotid)
    local itemlink = GetInventoryItemLink(unit, slotid)
    --if itemid ~= nil then
    if itemlink then
      --local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount = GetItemInfo(itemid)
      local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount = GetItemInfo(itemlink)
      itemcount = itemcount + 1
      levelaccum = levelaccum + iLevel
    else
      missedSlots = missedSlots + 1
    end
  end
  --for slotid = 5, 18, 1 do
  for slotid = 5, 17, 1 do
    --itemid = GetInventoryItemID(unit, slotid)
    local itemlink = GetInventoryItemLink(unit, slotid)
    --if itemid ~= nil then
    if itemlink then
      --local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount = GetItemInfo(itemid)
      local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount = GetItemInfo(itemlink)
      itemcount = itemcount + 1
      levelaccum = levelaccum + iLevel
    else
      missedSlots = missedSlots + 1
    end
  end
  if itemcount > 0 then
    levelavg = levelaccum / itemcount
  end
  if missedSlots > 0 then
    FixR:Echo("  inspect missed: "..missedSlots.." slots!")
  end
  return levelavg
end

--[[
local function bit(p)
  return 2 ^ (p - 1)  -- 1-based indexing
end
-- Typical call:  if hasbit(x, bit(3)) then ...
local function hasbit(x, p)
  return x % (p + p) >= p       
end
local function setbit(x, p)
  return hasbit(x, p) and x or x + p
end
local function clearbit(x, p)
  return hasbit(x, p) and x - p or x
end
--]]
local function init_inspectResultsFrame()
  local rowHeight = 18
  local i, v, iExpansion, expansion, iInstance, instance, iInstanceDifficulty, instanceDifficulty, bossId, bossCount, progress
  local lastExpFrame = nil
  
  inspectResultsFrame = CreateFrame("Frame", "FixR_inspectResultsFrame", UIParent)
  tinsert(UISpecialFrames, "FixR_inspectResultsFrame") --for ESC closing
  
  inspectResultsFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 0, 0)
  inspectResultsFrame:SetWidth(300)
  inspectResultsFrame:SetHeight(200)
  inspectResultsFrame:SetMovable(true)
  inspectResultsFrame:EnableMouse(true)
  inspectResultsFrame:RegisterForDrag("LeftButton")
  inspectResultsFrame:SetScript("OnDragStart", function(self) self:StartMoving(); end);
  inspectResultsFrame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing(); end);
  inspectResultsFrame:Hide()
  
  --black background
  inspectResultsFrame.texture = inspectResultsFrame:CreateTexture()
  inspectResultsFrame.texture:SetAllPoints(inspectResultsFrame)
  inspectResultsFrame.texture:SetTexture(0, 0, 0, 1)
  
  inspectResultsFrame.instanceShown = nil
  
  --create sub-frame for each expansion
  inspectResultsFrame.expansionFrames = {}
  
  for iExpansion, expansion in ipairs(statIds) do
    local expFrame = CreateFrame("Frame", nil, inspectResultsFrame)
    inspectResultsFrame.expansionFrames[iExpansion] = expFrame
    if lastExpFrame then
      expFrame:SetPoint("TOPLEFT", lastExpFrame, "BOTTOMLEFT", 0, 0)
    else
      expFrame:SetPoint("TOPLEFT", inspectResultsFrame, "TOPLEFT", 0, 0)
    end
    lastExpFrame = expFrame
    expFrame:SetWidth(150)
    expFrame:SetHeight(rowHeight)
    expFrame:Show()
    --black background
    expFrame.texture = expFrame:CreateTexture()
    expFrame.texture:SetAllPoints(expFrame)
    expFrame.texture:SetTexture(0.3, 0.3, 0.3, 1)
    
    local catButton = CreateFrame("Frame", nil, expFrame)
    expFrame.categoryButton = catButton
    catButton.expFrame = expFrame
    catButton.rowHeight = rowHeight
    catButton:SetPoint("TOPLEFT", expFrame, "TOPLEFT", 0, 0)
    catButton:SetWidth(150)
    catButton:SetHeight(rowHeight)
    catButton:Show()
    catButton:EnableMouse(true)
    catButton:SetScript("OnMouseUp", function(self, button, ...)
      if button == "RightButton" then
        if self.instanceFrameButtonsShown then
          local i, v
          i = 0
          for _, v in ipairs(self.instanceFrameButtons) do
            i = i + 1
            v:Hide()
          end
          self.expFrame:SetHeight(rowHeight)
          self.instanceFrameButtonsShown = false
        else
          local i, v
          i = 0
          for _, v in ipairs(self.instanceFrameButtons) do
            i = i + 1
            v:Show()
          end
          self.expFrame:SetHeight(self.rowHeight + self.rowHeight*i)
          self.instanceFrameButtonsShown = true
        end
        --self:SetSize(20, 20) -- protected
        --self:Hide() -- protected
        --self:EnableMouse(false) -- protected
        --self:SetFrameStrata("BACKGROUND") -- protected
        --/run EABFrame:SetFrameStrata("HIGH")
      end
    end);
    
    --black background
    catButton.texture = catButton:CreateTexture()
    catButton.texture:SetAllPoints(catButton)
    catButton.texture:SetTexture(0.6, 0.6, 0.6, 1)
    
    catButton.fsExp = catButton:CreateFontString(nil, "ARTWORK")
    catButton.fsExp:SetFont("Fonts\\FRIZQT__.TTF", 12)
    catButton.fsExp:SetPoint("TOPLEFT", 2, -2)
    catButton.fsExp:SetText("|cffff0000"..expansion["short"].."|r")
    
    catButton.instanceFrameButtons = {}
    catButton.instanceFrameButtonsShown = false
    local lastInstanceFrameButton = nil
    
    for iInstance, instance in ipairs(expansion["instances"]) do
      local instanceFrameButton = CreateFrame("Frame", nil, expFrame)
      catButton.instanceFrameButtons[iInstance] = instanceFrameButton
      if lastInstanceFrameButton then
        instanceFrameButton:SetPoint("TOPLEFT", lastInstanceFrameButton, "BOTTOMLEFT", 0, 0)
      else
        instanceFrameButton:SetPoint("TOPLEFT", catButton, "BOTTOMLEFT", 20, 0)
      end
      lastInstanceFrameButton = instanceFrameButton
      instanceFrameButton:SetWidth(130)
      instanceFrameButton:SetHeight(rowHeight)
      instanceFrameButton:Hide()
      
      instanceFrameButton.iInstance = iInstance
      instanceFrameButton.iExpansion = iExpansion
      
      instanceFrameButton.fsInstance = instanceFrameButton:CreateFontString(nil, "ARTWORK")
      instanceFrameButton.fsInstance:SetFont("Fonts\\FRIZQT__.TTF", 12)
      instanceFrameButton.fsInstance:SetPoint("TOPLEFT", 2, -2)
      instanceFrameButton.fsInstance:SetText("|cffffff00"..instance["short"].."|r")
      
      instanceFrameButton:EnableMouse(true)
      instanceFrameButton:SetScript("OnMouseUp", function(self, button, ...)
        if button == "LeftButton" then
          if inspectResultsFrame.instanceShown then
            inspectResultsFrame.instanceShown:Hide()
          end
          self.instanceFrame:Show()
          inspectResultsFrame.instanceShown = self.instanceFrame
        end
      end)
      
      local instanceFrame = CreateFrame("Frame", nil, inspectResultsFrame)
      instanceFrameButton.instanceFrame = instanceFrame
      instanceFrame:SetPoint("TOPRIGHT", inspectResultsFrame, "TOPRIGHT", 0, 0)
      instanceFrame:SetWidth(150)
      instanceFrame:SetHeight(200)
      instanceFrame:Hide()
      --background color
      instanceFrame.texture = instanceFrame:CreateTexture()
      instanceFrame.texture:SetAllPoints(instanceFrame)
      instanceFrame.texture:SetTexture(0.8, 0.8, 0.8, 1)
      
      --FixR:Echo("  - "..instance["short"]..":")
      local lastFsD = nil
      instanceFrame.fsDs = {}
      for iInstanceDifficulty, instanceDifficulty in ipairs(instance["d"]) do
        local fsD = instanceFrame:CreateFontString(nil, "ARTWORK")
        instanceFrame.fsDs[iInstanceDifficulty] = fsD
        fsD:SetFont("Fonts\\FRIZQT__.TTF", 12)
        if lastFsD then
          fsD:SetPoint("TOPLEFT", lastFsD, "BOTTOMLEFT", 0, -2)
        else
          fsD:SetPoint("TOPLEFT", 2, -2)
        end
        lastFsD = fsD
        
        bossCount = 0
        progress = 0
        for _, bossId in ipairs(instanceDifficulty["ids"]) do
          bossCount = bossCount + 1
          --progress = IncreaseIfKill(progress, GetComparisonStatistic(bossId))
        end
        
        fsD:SetText(format("%s%s: %d/%d", instanceDifficulty["p"] or "", instanceDifficulty["type"], 0, bossCount))
        
      end
    end
  end
  
  function inspectResultsFrame:showProgress(t)
    for iExpansion, expansion in ipairs(statIds) do
      local statsExpansion = t[iExpansion]
      local expFrame = self.expansionFrames[iExpansion]
      local catButton = expFrame.categoryButton
      for iInstance, instance in ipairs(expansion["instances"]) do
        local statsInstance = statsExpansion[iInstance]
        local instanceFrameButton = catButton.instanceFrameButtons[iInstance]
        local instanceFrame = instanceFrameButton.instanceFrame
        for iInstanceDifficulty, instanceDifficulty in ipairs(instance["d"]) do
          local statsDifficutly = statsInstance[iInstanceDifficulty]
          local fsD = instanceFrame.fsDs[iInstanceDifficulty]
          local bossCount = 0
          local progress = 0
          for bossIdI, bossId in ipairs(instanceDifficulty["ids"]) do
            bossCount = bossCount + 1
            progress = IncreaseIfKill(progress, statsDifficutly[bossIdI])
          end
          fsD:SetText(format("%s%s: %d/%d", instanceDifficulty["p"] or "", instanceDifficulty["type"], progress, bossCount))
        end
      end
    end
    self:Show()
  end
end

function InspectFrameEvents:INSPECT_READY(...)
  --if hasbit(fixRInspect_waitingFlags, bit(1)) then
  if waitingForInspect then
    waitingForInspect = false
    --fixRInspect_waitingFlags = clearbit(fixRInspect_waitingFlags, bit(1))
    local specID = GetInspectSpecialization("target")
    if specID > 0 then
      --local id, name, description, icon, background, role = GetSpecializationInfoByID(specID)
      local _, name, _, _, _, role = GetSpecializationInfoByID(specID)
      FixR:Echo("  Spec:")
      FixR:Echo("  - "..name.." ("..role..")")
    end
  end
end
function InspectFrameEvents:INSPECT_ACHIEVEMENT_READY(...)
  --if hasbit(fixRInspect_waitingFlags, bit(2)) then
  if waitingForStatistics then
    --fixRInspect_waitingFlags = clearbit(fixRInspect_waitingFlags, bit(2))
    waitingForStatistics = false
    
    --http://www.wowpedia.org/API_GetStatistic
    --http://www.wowwiki.com/API_GetStatistic
    --CategoryIds = {["Mists of Pandaria"] = 15164;}
    --/dump FixRInspect_GetStatisticId("Mists of Pandaria", "Jin'rokh the Breaker kills (10-player Normal Throne of Thunder)")
    --print(v, FixRInspect_GetStatisticId_ByCategoryId(15164, v))
    
    local i, v, expansion, instance, instanceDifficulty, bossId, bossCount, progress
    local stats = {}
    
    FixR:Echo("  Progress:")
    
    for expansionI, expansion in ipairs(statIds) do
      stats[expansionI] = {}
      for instanceI, instance in ipairs(expansion["instances"]) do
        stats[expansionI][instanceI] = {}
        FixR:Echo("  - "..instance["short"]..":")
        for instanceDifficultyI, instanceDifficulty in ipairs(instance["d"]) do
          stats[expansionI][instanceI][instanceDifficultyI] = {}
          bossCount = 0
          progress = 0
          for bossIdI, bossId in ipairs(instanceDifficulty["ids"]) do
            stats[expansionI][instanceI][instanceDifficultyI][bossIdI] = GetComparisonStatistic(bossId)
            bossCount = bossCount + 1
            progress = IncreaseIfKill(progress, GetComparisonStatistic(bossId))
          end
          FixR:Echo(format("    %s%s: %d/%d", instanceDifficulty["p"] or "", instanceDifficulty["type"], progress, bossCount))
        end
      end
    end
    FixR:Echo("-----------")
    inspectResultsFrame:showProgress(stats)
    
    -- Firelands
    local statIds_FLN = {"5964", "5966", "5968", "5970", "5972", "5974", "5976"} --Beth,Ryho,Shan,Alys,Bale,Majo,Ragn
    local progress_FLN = 0
    for i, v in ipairs(statIds_FLN) do
      progress_FLN = IncreaseIfKill(progress_FLN, GetComparisonStatistic(v))
    end
    local statIds_FLH = {"5965", "5967", "5969", "5971", "5973", "5975", "5977"} --Beth,Ryho,Shan,Alys,Bale,Majo,Ragn
    local progress_FLH = 0
    for i, v in ipairs(statIds_FLH) do
      progress_FLH = IncreaseIfKill(progress_FLH, GetComparisonStatistic(v))
    end
    
    --Dragon Soul
    local statIds_DSN = {"6153", "6155", "6157", "6159", "6161", "6163", "6165", "6167"} --Morc,Zono,Yors,Haga,Ultr,Blac,Spin,Deat
    local progress_DSN = 0
    for i, v in ipairs(statIds_DSN) do
      progress_DSN = IncreaseIfKill(progress_DSN, GetComparisonStatistic(v))
    end
    local statIds_DSH = {"6154", "6156", "6158", "6160", "6162", "6164", "6166", "6168"} --Morc,Zono,Yors,Haga,Ultr,Blac,Spin,Deat
    local progress_DSH = 0
    for i, v in ipairs(statIds_DSH) do
      progress_DSH = IncreaseIfKill(progress_DSH, GetComparisonStatistic(v))
    end
    
    --Throne of Thunder
    local statIds_ToTLFR = {"8141", "8148", "8153", "8158", "8163", "8168", "8173", "8178", "8183", "8188", "8193", "8198"}
    local progress_TOTLFR = 0
    for i, v in ipairs(statIds_ToTLFR) do
      progress_TOTLFR = IncreaseIfKill(progress_TOTLFR, GetComparisonStatistic(v))
    end
    local statIds_ToT10N = {"8142", "8149", "8154", "8159", "8164", "8169", "8174", "8179", "8184", "8189", "8194", "8199"}
    local progress_TOT10N = 0
    for i, v in pairs(statIds_ToT10N) do
      progress_TOT10N = IncreaseIfKill(progress_TOT10N, GetComparisonStatistic(v))
    end
    local statIds_ToT10H = {"8144", "8151", "8156", "8162", "8166", "8171", "8176", "8181", "8186", "8191", "8196", "8202", "8203"}
    local progress_TOT10H = 0
    for i, v in pairs(statIds_ToT10H) do
      progress_TOT10H = IncreaseIfKill(progress_TOT10H, GetComparisonStatistic(v))
    end
    local statIds_ToT25N = {"8143", "8150", "8155", "8160", "8165", "8170", "8175", "8182", "8185", "8190", "8195", "8200"}
    local progress_TOT25N = 0
    for i, v in pairs(statIds_ToT25N) do
      progress_TOT25N = IncreaseIfKill(progress_TOT25N, GetComparisonStatistic(v))
    end
    local statIds_ToT25H = {"8145", "8152", "8157", "8161", "8167", "8172", "8177", "8180", "8187", "8192", "8197", "8201", "8256"}
    local progress_TOT25H = 0
    for i, v in pairs(statIds_ToT25H) do
      progress_TOT25H = IncreaseIfKill(progress_TOT25H, GetComparisonStatistic(v))
    end
    
    FixR:Echo("  - FL: "..progress_FLN.."/7 nHC "..progress_FLH.."/7 HC")
    FixR:Echo("  - DS: "..progress_DSN.."/8 nHC "..progress_DSH.."/8 HC")
    FixR:Echo("  - TOT:")
    FixR:Echo("    lfr: "..progress_TOTLFR.."/12")
    FixR:Echo("    10: "..progress_TOT10N.."/12 nhc "..progress_TOT10H.."/13 hc")
    FixR:Echo("    25: "..progress_TOT25N.."/12 nhc "..progress_TOT25H.."/13 hc")
    
    ClearAchievementComparisonUnit()
  end
end

function M:Load()
  if InspectFrame == nil then
    InspectFrame = CreateFrame("Frame")
    InspectFrame:SetScript("OnEvent", function(self, event, ...)
      InspectFrameEvents[event](self, ...); -- call one of the functions above
    end);
    init_inspectResultsFrame()
  end
  local k, v
  for k, v in pairs(InspectFrameEvents) do
    InspectFrame:RegisterEvent(k); -- Register all events for which handlers have been defined
  end
end
function M:Unload()
  if InspectFrame then
    local k, v
    for k, v in pairs(InspectFrameEvents) do
      InspectFrame:UnregisterEvent(k); -- Unregister all events for which handlers have been defined
    end
    inspectResultsFrame:Hide()
  end
end

function M:SetOption(o, arg2)
  if o == "inspect" then
    local inRange = CheckInteractDistance("target", 1); -- 1 = Inspect, 28 yards
    local canInspect = CanInspect("target")
    if inRange and canInspect then
      local name, realm = UnitName("target")
      name = name or "Unknown"
      if realm then
        name = name.." - "..realm
      end
      FixR:Echo("Scanning "..name..":")
      --fixRInspect_waitingFlags = 0x3
      waitingForStatistics = true
      --/dump GetFramesRegisteredForEvent("INSPECT_ACHIEVEMENT_READY")
      SetAchievementComparisonUnit("target")
      --waitingForInspect = true
      --NotifyInspect("target")
    else
      FixR:Echo("out of range")
    end
  elseif o == "talents" then --/fixr inspect talents
    --[ [
    local inRange = CheckInteractDistance("target", 1); -- 1 = Inspect, 28 yards
    local canInspect = CanInspect("target")
    if inRange and canInspect then
      local playerName, realm = UnitName("target")
      playerName = playerName or "Unknown"
      if realm then
        playerName = playerName.." - "..realm
      end
      --local role, maxPoints = "unknown", 0
      --local numTabs = GetNumTalentTabs(true); --GetNumTalentTabs -> GetNumSpecializations
      --print("numTabs:", numTabs)
      --for t=1, numTabs do
      --  local id, name, desc, _, pointsSpent = GetTalentTabInfo(t, true)
      --  --DEFAULT_CHAT_FRAME:AddMessage("#"..id..", "..name.." ("..desc..") "..pointsSpent.." points spent:");
      --  if pointsSpent > maxPoints then
      --    maxPoints = pointsSpent
      --    role = name
      --  end
        --local numTalents = GetNumTalents(t, true);
        --for i=1, numTalents do
        --  local nameTalent, icon, tier, column, currRank, maxRank = GetTalentInfo(t, i, true);
        --  DEFAULT_CHAT_FRAME:AddMessage("- "..nameTalent..": "..currRank.."/"..maxRank);
        --end
      --end
      --FixR:Echo("Role of "..playerName..": "..role)
      if FixR:IsMop() then
        FixR:Echo("Scanning "..playerName..":")
        waitingForInspect = true
        NotifyInspect("target")
      else
        FixR:Echo("This feature is not supported in the Cataclysm client.")
      end
    else
      FixR:Echo("Cannot inspect.")
    end
    --]]
  end
end

function FixRInspect_GetStatisticId(CategoryTitle, StatisticTitle)
  local CategoryId = 0
  for _, CategoryId in pairs(GetStatisticsCategoryList()) do
    --local Title, ParentCategoryId, Something = GetCategoryInfo(CategoryId)
    local Title, _, _ = GetCategoryInfo(CategoryId)
    
    if Title == CategoryTitle then
      local i
      local statisticCount = GetCategoryNumAchievements(CategoryId)
      for i = 1, statisticCount do
        --local IDNumber, Name, Points, Completed, Month, Day, Year, Description, Flags, Image, RewardText = GetAchievementInfo(CategoryId, i)
        local IDNumber, Name, _, _, _, _, _, _, _, _, _ = GetAchievementInfo(CategoryId, i)
        if Name == StatisticTitle then
          return IDNumber
        end
      end
    end
  end
  return -1
end
function FixRInspect_GetStatisticId_ByCategoryId(CategoryId, StatisticTitle)
  local i
  local statisticCount = GetCategoryNumAchievements(CategoryId)
  for i = 1, statisticCount do
    local IDNumber, Name, _, _, _, _, _, _, _, _, _ = GetAchievementInfo(CategoryId, i)
    if Name == StatisticTitle then
      return IDNumber
    end
  end
	return -1
end
function FixRInspect_DumpCategoryId(CategoryTitle)
  local CategoryId = 0
  for _, CategoryId in pairs(GetStatisticsCategoryList()) do
    local Title, _, _ = GetCategoryInfo(CategoryId)
    if Title == CategoryTitle then
      print("cat:", CategoryId, CategoryTitle)
      return
    end
  end
end
function FixRInspect_DumpStatisticIds_ByCategoryId(CategoryId)
  local i
  local statisticCount = GetCategoryNumAchievements(CategoryId)
  for i = 1, statisticCount do
    local IDNumber, Name, _, _, _, _, _, _, _, _, _ = GetAchievementInfo(CategoryId, i)
    print("stat:", IDNumber, Name)
  end
end
--CategoryIds = {["Mists of Pandaria"] = 15164;}
--/dump FixRInspect_SaveStatisticIds_ByCategoryId(15164)
function FixRInspect_SaveStatisticIds_ByCategoryId(CategoryId)
  local i
  local statisticCount = GetCategoryNumAchievements(CategoryId)
  M.O["statIDs"] = {}
  for i = 1, statisticCount do
    local IDNumber, Name, _, _, _, _, _, _, _, _, _ = GetAchievementInfo(CategoryId, i)
    print("stat:", IDNumber, Name)
    M.O["statIDs"][IDNumber] = Name
  end
end

--[[
{
[5981] = "Occu'thar kills (Baradin Hold)"
[6170] = "Alizabal kills (Baradin Hold)"
[6989] = "Sha of Anger kills (Kun-Lai Summit)",
[6990] = "Salyis's Warband kills (Valley of the Four Winds)",
[8146] = "Nalak kills",
[8147] = "Oondasta kills",
[8291] = "Gastropod meals provided"
}
--]]